package envoy.server.processors;

import java.io.IOException;

import envoy.data.IdGenerator;
import envoy.event.IdGeneratorRequest;
import envoy.server.ObjectProcessor;
import envoy.server.net.ObjectWriteProxy;

/**
 * Project: <strong>envoy-server-standalone</strong><br>
 * File: <strong>IdGeneratorRequestProcessor.java</strong><br>
 * Created: <strong>28 Jan 2020</strong><br>
 *
 * @author KSKE
 * @since Envoy Server Standalone v0.1-alpha
 */
public class IdGeneratorRequestProcessor implements ObjectProcessor<IdGeneratorRequest> {

	private static long			currentId	= 0;
	private static final long	ID_RANGE	= 2;

	@Override
	public Class<IdGeneratorRequest> getInputClass() { return IdGeneratorRequest.class; }

	@Override
	public void process(IdGeneratorRequest input, long socketId, ObjectWriteProxy writeProxy) throws IOException {
		System.out.println("Received id generation request.");

		IdGenerator generator = new IdGenerator(currentId, ID_RANGE);
		currentId += ID_RANGE;

		System.out.println("Sending new id generator " + generator);
		writeProxy.write(socketId, generator);
	}
}
